#ifndef ClipboardModuleIncluded
#define ClipboardModuleIncluded
#module ClipboardModule

#uselib "kernel32.dll"      ;O[o
#func GlobalAlloc   "GlobalAlloc"   int, int    ;JK{
#func GlobalFree    "GlobalFree"    int
#func GlobalLock    "GlobalLock"    int         ;K{
#func GlobalUnlock  "GlobalUnlock"  int
#func GlobalSize    "GlobalSize"    int
#define GMEM_FIXED      0           ;Œ胁mۂ
#define GMEM_MOVEABLE   2           ;ړ\mۂ
#define GMEM_ZEROINIT   $40         ;0ŏ
#define GMEM_SHARE      8192        ;DDE֐Nbv{[hŎgpꍇw肷
#define GHND            $42         ;GMEM_MOVEABLE + GMEM_ZEROINIT

#uselib "kernel32.dll"      ;t@CpXϊ
#func GetFullPathName "GetFullPathNameA" str, int, var, nullptr

#uselib "user32.dll"
#func OpenClipboard     "OpenClipboard"     int
#func CloseClipboard    "CloseClipboard"
#func GetClipboardData  "GetClipboardData"  int
#func SetClipboardData  "SetClipboardData"  int, int
#func EmptyClipboard    "EmptyClipboard"
#func IsClipboardFormatAvailable "IsClipboardFormatAvailable" int
#define CF_TEXT     1
#define CF_BITMAP   2
#define CF_HDROP    15
#func RegisterClipboardFormat "RegisterClipboardFormatA" str
#define CFSTR_PREFERREDDROPEFFECT   "Preferred DropEffect"
#define DROPEFFECT_NONE             0
#define DROPEFFECT_COPY             1   ;Rs[sł܂B
#define DROPEFFECT_MOVE             2   ;ړsł܂B
#define DROPEFFECT_LINK             4   ;hbvꂽf[^ƌ̃f[^Ƃ̃Nmł܂B
#define DROPEFFECT_SCROLL   $80000000   ;hbO XN[sł邱Ƃ܂B

#uselib "USER32.dll"
#func GetDC     "GetDC"     int
#func ReleaseDC "ReleaseDC" int, int

#uselib "GDI32.dll"
#func CreateCompatibleDC "CreateCompatibleDC" int
#func DeleteDC          "DeleteDC"      int
#func SelectObject      "SelectObject"  int, int
#func DeleteObject      "DeleteObject"  int
#func CreateCompatibleBitmap "CreateCompatibleBitmap" int, int, int
#func BitBlt            "BitBlt"        int, int, int, int, int, int, int, int, int
#func GetClipBox        "GetClipBox"    int, var

#uselib "shell32.dll"       ;hbOhbvAPI
#func DragQueryFile "DragQueryFileA" int, int, var, int

#deffunc ClipB_GetText var t
    t = ""
    IsClipboardFormatAvailable CF_TEXT  : if stat == 0  : return ; eLXg͂Ȃ
    OpenClipboard hwnd ; Nbv{[hJ
    if stat {
        GetClipboardData CF_TEXT  : ib = stat   ;   O[õnh擾
        GlobalSize ib  : ib(1) = stat   ;   TCY
        GlobalLock ib  : ib(2) = stat   ;   bN
        dupptr dp , ib(2) , ib(1) , 2
        t = dp  ;           f[^ɓꂽI
        GlobalUnlock ib ;   AbN
        CloseClipboard  ;   Nbv{[h
    }
    return

#deffunc ClipB_SetText str s
    GlobalAlloc GMEM_ZEROINIT | GMEM_SHARE, strlen(s) + 2 ;O[om
    ib = stat                       ;O[õnh
    if ib == 0  : return 0          ;VbpCIH
    GlobalLock ib  : ib(1) = stat   ;bN
    dupptr dp, ib(1), strlen(s) + 2, 2  : dp = s    ;i[B
    GlobalUnlock ib                 ;AbN
    OpenClipboard hwnd              ;Nbv{[hJ
    if stat {
        EmptyClipboard              ;Nbv{[hɂ
        SetClipboardData CF_TEXT, ib;O[on
        CloseClipboard              ;Nbv{[h
        return 1                    ;O[o̓Nbv{[h̊ǊɁB
    }
    GlobalFree ib   ;nȂꍇ͎͂ŊJB
    return 0

#deffunc ClipB_GetBmpSize var x, var y
    x = 0  : y = 0
    IsClipboardFormatAvailable CF_BITMAP  : if stat == 0  : return  ;摜H
    OpenClipboard hwnd
    if stat {
        GetClipboardData CF_BITMAP
        ib = stat, 0, 0, 0, 0, 0
        SelectObject hdc, ib(0)  : ib(1) = stat ;łB
        GetClipBox   hdc, ib(2)     ;ő傫B
        SelectObject hdc, ib(1)     ;߂
        CloseClipboard
        x = ib(4)  : y = ib(5)      ;
    }
    return

#deffunc ClipB_GetBmp int x, int y, int w, int h
    IsClipboardFormatAvailable CF_BITMAP
    if stat == 0  : return 0    ;clipboardbitmapȂ

    OpenClipboard hwnd
    if stat {
        GetClipboardData CF_BITMAP  ;rbg}bṽnh擾
        ib = stat, 0, 0, 0, 0, 0, 0
        ;Nbv{[hHSPł̓rbg}bv̌`Ⴄ...
        CreateCompatibleDC hdc  : ib(1) = stat  ;VfoCXReLXg쐬
        SelectObject ib.1, ib   : ib(2) = stat  ;BITMAPύX
        BitBlt hdc, ginfo(22), ginfo(23), w, h, ib(1), x, y, $00CC0020  ;Rs[
        SelectObject ib(1), ib(2)   ;BITMAPǂ
        DeleteDC ib(1)              ;foCXReLXg폜
        CloseClipboard  : return 1
    }
    return 0

#deffunc ClipB_SetBmp int x, int y, int w, int h
    // ib = HBitmap, DummyHBitmap, WorkHDC, miracleHDC
    GetDC                               : ib(3) = stat
    CreateCompatibleDC      ib(3)       : ib(2) = stat
    CreateCompatibleBitmap  ib(3), w, h : ib(0) = stat
    ReleaseDC               0, ib(3)
    SelectObject            ib(2), ib   : ib(1) = stat
    BitBlt  ib(2), 0, 0, w, h, hdc, x, y, $00CC0020
    SelectObject            ib(2), ib(1)
    DeleteDC                ib(2)

    OpenClipboard hwnd
    if stat {
        EmptyClipboard
        SetClipboardData CF_BITMAP, ib(0)
        CloseClipboard
    }
    DeleteObject ib(0)
    return

#deffunc ClipB_GetFile var t    ;Nbv{[ht@CpXƂĂ݂悤
    t = ""  : sb = ""
    OpenClipboard hwnd
    if stat == 0  : return 0                ;Nbv{[hJȂ

    ib = 0, 0, 0, 0, 0      ;returnl, GMhandle, GMpinter, FileCnt, temp

    IsClipboardFormatAvailable CF_HDROP             ;t@C邩ȁH
    if stat {                                       ;t@C_(^ ^)^
        GetClipBoardData CF_HDROP  : ib(1) = stat   ;t@C̋l܂GMƁ[
        ;if ib(1) == 0                                  ;HLČ̂ɂI
        GlobalLock ib(1)  : ib(2) = stat
        DragQueryFile ib(2), -1, ib(3), 0           ;t@C[
        ib(3) = stat
        repeat ib(3)
            DragQueryFile ib(2), cnt, sb, 0         ;܂͕擾
            ib(4) = stat + 1  : memexpand sb, ib(4) ;vH
            DragQueryFile ib(2), cnt, sb, ib(4)     ;t@C擾
            t += sb + "\n"                          ;AI
        loop
        GlobalUnlock ib(1)
        ib = ib(3)                                  ;t@Cꗗ擾B
    }
    CloseClipboard                          ;J߂͓SB
    return ib

#defcfunc ClipB_GetFileMode
    OpenClipboard hwnd
    if stat == 0  : return 0                        ;Nbv{[hJȂ

    ib = 0, 0, 0
    RegisterClipboardFormat CFSTR_PREFERREDDROPEFFECT
    ib(1) = stat                                    ;DragEffect̎ʎq
    if ib(1) {                                      ;sĂƂ͍lɂ...
        IsClipboardFormatAvailable ib(1)            ;ʂ邩ȁH
        if stat {                                   ;B
            GetClipBoardData ib(1)  : ib(2) = stat  ;nh
            GlobalLock ib(2)                        ;Lb`
            dupptr dp, stat, 4, 4                   ;^[QbgbNII
            ib = dp                                 ;W
            GlobalUnlock ib(2)                      ;[X
        }
    }
    CloseClipboard
    return ib

#deffunc ClipB_SetFile str s, int m, local t
    ib    = 0, 0, 0     ;hMem(path), hMem(effect), effʎq
    ib(3) = 0, 0, 0     ;file, filenullR~, tempo
    t = s               ;t@CpXꗗ
    sb = ""
    notesel t

    repeat noteinfo(0)              ;܂͉炦
        noteget sb, cnt
        GetFullPathName sb, 0, sb       ;̕ϐ̓_~[(ʂ)
        ib(5) = stat                    ;tpX̕(ʂR~)
        memexpand sb, ib(5)             ;tpXmɊi[ł悤
        GetFullPathName sb, ib(5), sb   ;΃pXQg[
        noteadd sb, cnt, 1              ;΃pXƂ̈ʒuɖ߂
        ib(4) += ib(5)                  ;t@CpX(null)ɉZ
        ib(3) ++                        ;t@C₷
    loop

    GlobalAlloc GMEM_ZEROINIT | GMEM_SHARE, ib(4) + 22  ;GMm(N)
    ib = stat
    GlobalLock ib
    dupptr dp, stat, ib(4) + 22, 4  ;[(Null)͂ȂB
    dp    = 20          ;t@C܂łoffset
    dp(1) = 0, 0        ;WX,Y
    dp(3) = 0           ;ꏊ(NCAg̈H)
    dp(4) = 0           ;pXi[@(0: 1:㎮)
    ib(5) = 20
    repeat ib(3)
        noteget sb, cnt
        memcpy dp, sb, strlen(sb) + 1, ib(5);łNullꏏɁB
        ib(5) += strlen(sb) + 1
    loop
    poke dp, ib(5), 0   ;Ô߁Aӂ(̃kk)B
    GlobalUnlock ib

    noteunsel

    GlobalAlloc GMEM_ZEROINIT | GMEM_SHARE, 4   ;GMm
    ib(1) = stat
    GlobalLock ib(1)
    dupptr dp, stat, 4, 4
    dp = m
    GlobalUnlock ib(1)

    RegisterClipboardFormat CFSTR_PREFERREDDROPEFFECT
    ib(2) = stat                    ;DragEffect̎ʎq

    OpenClipboard hwnd              ;Nbv{[hJ
    if stat {
        EmptyClipboard              ;Nbv{[hɂ
        SetClipboardData CF_HDROP, ib;O[on
        SetClipboardData ib(2), ib(1);O[on
        CloseClipboard              ;Nbv{[h
        return ib(3)    ;O[o̓Nbv{[h̊ǊɁB
    }
    GlobalFree ib       ;tsꍇ͎͂ŊJB
    GlobalFree ib(1)    ;B
    return 0

#deffunc ClipB_SetEmpty
    OpenClipboard hwnd
    if stat == 0  : return 0
    EmptyClipboard
    CloseClipboard
    return 1

; http://www.tvg.ne.jp/menyukko/ ; Copyright(C) 2005-2011 ߓa All rights reserved.
#global
#endif
